# QuakeNet deop protection v1.51 (tested on eggdrop1.6.13)
# by Patrick "Jack" Wedekind (email: jack@quakenet.org)
# uses QuakeNet channelservices L or Q to reop/revoice itself when somebody deops or devoices it (the bot must be authed with Q and have at least the +o/+v flag on the chanlev)
# .chanset #channel +deopprot on the partyline will enable this feature for a channel.
#
# Changes in 1.2:
# - You can now kickban people who deop the bot for a specified time (you can set it in the SETTINGS part of this script).
# - To enable this new feature, type .chanset #channel +deoppunish on the partyline. 
# - Note: deoppunish only works when the bot is deoped.
#
# Changes in 1.3:
# - Silly bug fixed.
#
# Changes in 1.4:
# - Small bug fixed (bot doesn't try to punish server deops anymore).
#
# Changes in 1.41:
# - Another small bug fixed.
#
# Changes in 1.5:
# - Removed devoice protection, seemed to be a rather useless feature
# - The bot will now deop first and then ban to beat lame scripts
#
# Changes in 1.51:
# - Small bug fixed


### SETTINGS ###
#
# specify the bantime that is used when deoppunish is triggered (in minutes; default is 120 minutes = 2 hours)
set deoppbantime "120"
#
# specify the kickmessage that is used when deoppunish is triggered
set deopkick "Don't deop me!"



### CODE ###

setudef flag deopprot
setudef flag deoppunish

bind mode - * check_modes

proc check_modes {nick uhost hand chan mode arg} {
global botnick deopkick deoppbantime
foreach i [channel info $chan] {
if {($mode == "-o") && ($arg == $botnick) && ([string match "+deoppunish" $i]) && ([onchan L $chan]) && ($nick != "*.quakenet.org")} {
putserv "PRIVMSG L :op $chan"
putserv "MODE $chan -o+b $nick *!$uhost"
putserv "KICK $chan $nick :$deopkick"
timer $deoppbantime [subst {putserv "MODE $chan -b *!$uhost"}]
} else {
if {($mode == "-o") && ($arg == $botnick) && ([string match "+deoppunish" $i]) && ([onchan Q $chan]) && ($nick != "*.quakenet.org")} {
putserv "PRIVMSG Q :op $chan"
putserv "MODE $chan -o+b $nick *!$uhost"
putserv "KICK $chan $nick :$deopkick"
timer $deoppbantime [subst {putserv "MODE $chan -b *!$uhost"}]
} else {
if {($mode == "-o") && ($arg == $botnick) && ([string match "+deopprot" $i]) && ([onchan L $chan])} {
putserv "PRIVMSG L :op $chan"
} else {
if {($mode == "-o") && ($arg == $botnick) && ([string match "+deopprot" $i]) && ([onchan Q $chan])} {
putserv "PRIVMSG Q :op $chan"
}
}
}
}
}
}

putlog "QuakeNet deop protection v1.51 by Jack loaded."